﻿
// ReimuIconDlg.cpp : 実装ファイル
//

#include "pch.h"
#include "framework.h"
#include "ReimuIcon.h"
#include "ReimuIconDlg.h"
#include "afxdialogex.h"
#include "CSettingDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// アプリケーションのバージョン情報に使われる CAboutDlg ダイアログ

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// ダイアログ データ
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV サポート

// 実装
protected:
	DECLARE_MESSAGE_MAP()
public:
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CReimuIconDlg ダイアログ



CReimuIconDlg::CReimuIconDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_REIMUICON_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_iRate = 0;
	m_iWipeDir = 0;
	m_iWipeCycleTime = 0;
}

void CReimuIconDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ST_REIMU, m_cReimuText);
}

BEGIN_MESSAGE_MAP(CReimuIconDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CTLCOLOR()
//	ON_BN_CLICKED(IDC_BTN_COLSETTING, &CReimuIconDlg::OnClickedBtnColsetting)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_MENU_SETTING, &CReimuIconDlg::OnMenuSetting)
	ON_WM_SIZE()
	ON_WM_TIMER()
	ON_COMMAND(ID_MENU_LEFT_TO_RIGHT, &CReimuIconDlg::OnMenuLeftToRight)
	ON_COMMAND(ID_MENU_RIGHT_TO_LEFT, &CReimuIconDlg::OnMenuRightToLeft)
	ON_COMMAND(ID_MENU_CENTER, &CReimuIconDlg::OnMenuCenter)
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CReimuIconDlg メッセージ ハンドラー

BOOL CReimuIconDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// "バージョン情報..." メニューをシステム メニューに追加します。

	// IDM_ABOUTBOX は、システム コマンドの範囲内になければなりません。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// このダイアログのアイコンを設定します。アプリケーションのメイン ウィンドウがダイアログでない場合、
	//  Framework は、この設定を自動的に行います。
	SetIcon(m_hIcon, TRUE);			// 大きいアイコンの設定
	SetIcon(m_hIcon, FALSE);		// 小さいアイコンの設定

	// TODO: 初期化をここに追加します。
	this->m_dwTextColor = RGB(0, 0, 0);								// 文字色を黒で初期化
	this->m_dwBkColor = RGB(255, 255, 255);							// 背景色を白で初期化
	this->m_cBrushBk.CreateSolidBrush(m_dwBkColor);					// 背景色塗りつぶし用ブラシ初回作成
	this->m_cBkBitmap.LoadBitmap(IDB_BITMAP_ROOM);					// リソースからビットマップをロードする
	// Wipe Rateを初期化
	this->m_iRate = 100;		// 100% から始める

	// ワイプの周期を初期化
	this->m_iWipeCycleTime = 50;	// 50ms
	// タイマ起動
	this->m_iWipeTimerId = this->SetTimer(ID_TIMER_RATE, m_iWipeCycleTime, NULL);

	return TRUE;  // フォーカスをコントロールに設定した場合を除き、TRUE を返します。
}

void CReimuIconDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// ダイアログに最小化ボタンを追加する場合、アイコンを描画するための
//  下のコードが必要です。ドキュメント/ビュー モデルを使う MFC アプリケーションの場合、
//  これは、Framework によって自動的に設定されます。

void CReimuIconDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 描画のデバイス コンテキスト

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// クライアントの四角形領域内の中央
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// アイコンの描画
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		// ダイアログの描画

		// ダイアログのデバイスコンテキストを取得
		CPaintDC dc(this);

		// 上記DCの複製を作成する
		CDC dcImage;
		if (!dcImage.CreateCompatibleDC(&dc)) return;

		// ビットマップオブジェクトを取得
		BITMAP bm;
		m_cBkBitmap.GetBitmap(&bm);

		// ダイアログのクライアント領域の矩形を取得
		CRect rect;
		this->GetClientRect(&rect);
		// 描画用ビットマップを設定＆現ビットマップを一時保存
		CBitmap* pOldBitmap = dcImage.SelectObject(&m_cBkBitmap);

		// ビットマップを伸張転送する
		dc.SetStretchBltMode(HALFTONE);	// 色補完をする

		// 転送先の幅をRATEから計算する
		int dstWidth = rect.Width() * m_iRate / 100;

		if (m_iRate == 100) {
			dc.StretchBlt(0, 0, rect.Width(), rect.Height(), &dcImage,
				0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);
		}
		else {
			// Wipe 左から右
			if (m_iWipeDir == LEFT_TO_RIGHT) {
				dc.StretchBlt(0, 0, dstWidth, rect.Height(), &dcImage,
					0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);
			}
			// Wipe 右から左
			else if (m_iWipeDir == RIGHT_TO_LEFT) {
				// 転送先開始位置を調整する
				int startx = rect.Width() - dstWidth; 
				dc.StretchBlt(startx, 0, dstWidth, rect.Height(), &dcImage,
					0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);
			}
			// Wipe 中央から外へ
			else if (m_iWipeDir == CENTER) {
				// 転送先開始位置を調整する
				int startx = (rect.Width() - dstWidth) / 2; 
				dc.StretchBlt(startx, 0, dstWidth, rect.Height(), &dcImage,
					0, 0, bm.bmWidth, bm.bmHeight, SRCCOPY);
			}
		}
		// 元のビットマップに戻す
		dcImage.SelectObject(pOldBitmap);

		CDialogEx::OnPaint();
	}
}

// ユーザーが最小化したウィンドウをドラッグしているときに表示するカーソルを取得するために、
//  システムがこの関数を呼び出します。
HCURSOR CReimuIconDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}



HBRUSH CReimuIconDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor)
{
	HBRUSH hbr = CDialogEx::OnCtlColor(pDC, pWnd, nCtlColor);

	// TODO: ここで DC の属性を変更してください。
	int id = pWnd->GetDlgCtrlID();
	if (id == IDC_ST_REIMU) {
		pDC->SetTextColor(m_dwTextColor);			// 文字色設定
		pDC->SetBkMode(TRANSPARENT);				// 透過モードに設定
	}
	// TODO: 既定値を使用したくない場合は別のブラシを返します。
	return m_cBrushBk;								// 背景塗りつぶし用ブラシを返す
}


//void CReimuIconDlg::OnClickedBtnColsetting()
//{
	// TODO: ここにコントロール通知ハンドラー コードを追加します。
//	CSettingDlg dlg;
//	dlg.m_dwTextColor = this->m_dwTextColor;// ダイアログに文字色初期値を設定
//	dlg.m_dwBkColor = this->m_dwBkColor;	// ダイアログに背景色初期値を設定
//	if (IDOK == dlg.DoModal()) {
//
//		this->m_dwTextColor = dlg.m_dwTextColor;// ダイアログの文字色設定状態を取得する
//		this->m_dwBkColor = dlg.m_dwBkColor;	// ダイアログの背景色設定状態を取得する
		// 背景塗りつぶし用ブラシを再作成
//		m_cBrushBk.DeleteObject();				// 今までのブラシオブジェクトを破棄
//		m_cBrushBk.CreateSolidBrush(m_dwBkColor);// 新しい背景色でブラシを再作成
//		this->Invalidate();						// 画面全体を再描画する
//	}
//}


void CReimuIconDlg::OnContextMenu(CWnd* /*pWnd*/, CPoint point)
{
	// TODO: ここにメッセージ ハンドラー コードを追加します。
	CMenu menu;
	CPoint pt = point;
	if (menu.LoadMenu(IDR_MENU_POPUP)) {
		CMenu* pSubMenu = menu.GetSubMenu(0);	// 最初のメニューのサブメニューを取得
		if (pSubMenu != NULL) {
			pSubMenu->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, this);
		}
	}
}


void CReimuIconDlg::OnMenuSetting()
{
	// TODO: ここにコマンド ハンドラー コードを追加します。
	CSettingDlg dlg;
	dlg.m_dwTextColor = this->m_dwTextColor;// ダイアログに文字色初期値を設定
	dlg.m_dwBkColor = this->m_dwBkColor;	// ダイアログに背景色初期値を設定
	// 表示中の文字列を設定ダイアログに設定
	this->m_cReimuText.GetWindowText(dlg.m_cText);

	// ワイプタイマー周期を設定
	dlg.m_iWipeCycleTime = this->m_iWipeCycleTime;

	if (IDOK == dlg.DoModal()) {

		this->m_dwTextColor = dlg.m_dwTextColor;// ダイアログの文字色設定状態を取得する
		this->m_dwBkColor = dlg.m_dwBkColor;	// ダイアログの背景色設定状態を取得する
		// 背景塗りつぶし用ブラシを再作成
		m_cBrushBk.DeleteObject();				// 今までのブラシオブジェクトを破棄
		m_cBrushBk.CreateSolidBrush(m_dwBkColor);// 新しい背景色でブラシを再作成
		// 設定ダイアログの設定文字列を文字列表示コントールに設定
		m_cReimuText.SetWindowText(dlg.m_cText);

		// 設定ダイアログからワイプ制御周期を取得
		this->m_iWipeCycleTime = dlg.m_iWipeCycleTime;
		// ワイプレートを計算する周期タイマーを再設定する
		this->KillTimer(this->m_iWipeTimerId);	// タイマーを一旦破棄する
		// タイマ起動
		this->m_iWipeTimerId = this->SetTimer(ID_TIMER_RATE, m_iWipeCycleTime, NULL);
		// ダイアログを再表示
		this->Invalidate();						
	}
}


void CReimuIconDlg::OnSize(UINT nType, int cx, int cy)
{
	CDialogEx::OnSize(nType, cx, cy);

	// TODO: ここにメッセージ ハンドラー コードを追加します。

	// 文字ラベルのウィンドウをX方向で画面の中央に表示するように調整

	// OnSizeは配下のコントロールウインドウを生成する前に1回呼ばれる
	// なので、該当コントロールのWindowハンドルが有効なときだけ処理する
	if (::IsWindow(m_cReimuText.m_hWnd)) {
		// ダイアログのクライアント領域の矩形を取得する
		CRect clientRect;
		this->GetClientRect(&clientRect);

		// 文字列ラベルのクライアント座標を取得する
		CRect labelRect;
		this->m_cReimuText.GetWindowRect(&labelRect);
		this->ScreenToClient(&labelRect);

		//クライアント領域のX座標で中央になるようにラベルコントロールの
		//X座標を計算する
		int x = (clientRect.Width() - labelRect.Width()) / 2;

		//ラベルコントロールの位置を調整する
		m_cReimuText.MoveWindow(x, labelRect.top, labelRect.Width(), labelRect.Height());
	}
	// サイズ変更時に再表示を促す
	this->Invalidate();
}


void CReimuIconDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ここにメッセージ ハンドラー コードを追加するか、既定の処理を呼び出します。
	if (nIDEvent == ID_TIMER_RATE) {
		// Wipeの転送率を増やす
		if (m_iRate < 100) {
			m_iRate += 1;
			if (m_iRate <= 100) {

			}
			else {
				m_iRate = 100;
			}
			this->Invalidate(FALSE);	// ワイプ中は背景を塗りつぶさない
		}
	}
	CDialogEx::OnTimer(nIDEvent);
}


void CReimuIconDlg::OnMenuLeftToRight()
{
	// TODO: ここにコマンド ハンドラー コードを追加します。
	m_iRate = 0;
	m_iWipeDir = LEFT_TO_RIGHT;
	this->Invalidate();
}


void CReimuIconDlg::OnMenuRightToLeft()
{
	// TODO: ここにコマンド ハンドラー コードを追加します。
	m_iRate = 0;
	m_iWipeDir = RIGHT_TO_LEFT;
	this->Invalidate();
}


void CReimuIconDlg::OnMenuCenter()
{
	// TODO: ここにコマンド ハンドラー コードを追加します。
	m_iRate = 0;
	m_iWipeDir = CENTER;
	this->Invalidate();
}


void CReimuIconDlg::OnDestroy()
{
	CDialogEx::OnDestroy();

	// TODO: ここにメッセージ ハンドラー コードを追加します。
	this->KillTimer(this->m_iWipeTimerId);	// タイマーを破棄する

}
